#include <stdio.h>
#include <string.h>
#include <dos.h>
#include "vga.h"

void set_video_mode(int mode);
void clearscr(unsigned char col);
void putpixel(int x, int y, unsigned char col);

int main(void)
{
	int i;
	set_video_mode(0x12);

	clearscr(1);	/* clear screen to dark blue */

	/* draw a red X */
	for(i=0; i<40; i++) {
		putpixel(300 + i, 220 + i, 12);
		putpixel(300 + i, 259 - i, 12);
	}

	while(!kbhit());
	getch();

	set_video_mode(2);
}

void set_video_mode(int mode)
{
	union REGS regs = {0};
	regs.x.ax = mode;
	int86(0x10, &regs, &regs);
}

void clearscr(unsigned char col)
{
	set_write_mode(2);		/* write mode 2: unpack nibble into bitplanes */
	set_plane_mask(0xf);	/* enable all bitplanes */

	/* we're writing 8 pixels at a time: 640/8*480 = 38400 bytes */
	memset(MK_FP(0xa000, 0), col, 38400);
}

void putpixel(int x, int y, unsigned char col)
{
	/* pointer to the correct byte in video memory
	 * 80 bytes across and shift x right by 3, because each byte is 8 pixels
	 */
	unsigned char far *dest = MK_FP(0xa000, y * 80 + (x >> 3));

	/* assume we're in write mode 2 and all planes are enabled (see clearscr) */

	/* do a read to load current byte across all bitplanes into the latches */
	unsigned char tmp = *dest;

	/* set the bitmask to preserve all pixels except the one we're setting
	 * 1 bits use our color value, 0 bits use whatever is in the latches
	 */
	set_bitmask(0x80 >> (x & 7));
	*dest = col;
}
