#ifndef VGA_H_
#define VGA_H_

#define VGA_AC			0x3c0
#define VGA_SC_INDEX	0x3c4
#define VGA_SC_DATA		0x3c5
#define VGA_GC_INDEX	0x3ce
#define VGA_GC_DATA		0x3cf
#define VGA_CRTC_INDEX	0x3d4
#define VGA_CRTC_DATA	0x3d5

#define VGA_STAT0		0x3c2
#define VGA_STAT1		0x3da

#define VGA_SC_REG_MAPMASK	2

#define VGA_GC_REG_SR		0
#define VGA_GC_REG_EN_SR	1
#define VGA_GC_REG_ROT		3
#define VGA_GC_REG_MODE		5
#define VGA_GC_REG_MASK		8


#define set_write_mode(mode) \
	outport(VGA_GC_INDEX, VGA_GC_REG_MODE | ((unsigned int)(mode) << 8))

#define set_plane_mask(mask) \
	outport(VGA_SC_INDEX, VGA_SC_REG_MAPMASK | ((unsigned int)(mask) << 8))

#define set_bitmask(mask) \
	outport(VGA_GC_INDEX, VGA_GC_REG_MASK | ((unsigned int)(mask) << 8))

#endif	/* VGA_H_ */
